#!/usr/bin/env python

import os
from operator import *
from copy import copy

def read_file(name):
	res = []
	f = open(name).readlines()
	for l in f[:32]:
		l = l.strip().split('   ')
		res += l

	tot = 0.0
	nums = []
	bits = []

	for l in res:
		l = l.strip().split(" ")
		#print l
		n = float(l[3])
		#b = int(l[3][:1])
		#if not b:
		#	n = -n
		#print l[0], n
		tot += n
		nums.append(n)
		bits.append(l[1])
	
	avg = tot / 128.
	num_ok = 0
	lim = 0.0255
	for b, n in zip(bits, nums):
		if b:
			if n < avg + lim:
				num_ok += 1
		else:
			if n > avg + lim:
				num_ok += 1
		print b, n, n-avg
	print avg, num_ok

def print_match(bits, nums):

	#for n in nums:
	#	tot += n
	
	avg = 0 # tot / 128.
	num_ok = 0
	lim = 0
	for b, n in zip(bits, nums):
		if b:
			if n > avg + lim:
				num_ok += 1
		else:
			if n < avg + lim:
				num_ok += 1
		print b, n, n-avg
	print "ok:", num_ok

def read_res_file():
	res = []
	f = open("row.0.txt").readlines()
	for l in f[:32]:
		l = l.strip().split('   ')
		res += l

	tot = 0.0
	nums = []
	bits = []

	for l in res:
		l = l.strip().split(" ")
		#print l
		n = float(l[3])
		#b = int(l[3][:1])
		#if not b:
		#	n = -n
		#print l[0], n
		tot += n
		nums.append(n)
		bits.append(l[1])
	
	avg = tot / 128.
	num_ok = 0
	lim = 0.0255
	for b, n in zip(bits, nums):
		if b:
			if n < avg + lim:
				num_ok += 1
		else:
			if n > avg + lim:
				num_ok += 1
		print b, n, n-avg
	print avg, num_ok

def read_results_file(name):
	res = []
	key = []
	f = open(name).readlines()
	if len(f) != 129:
		return res, key
	for l in f[:128]:
		l = l.strip().split(" ")
		#print l
		res.append(float(l[1]))
		key.append(int(l[3][:1]))
	return res, key

def test1(name):
	res = []
	f = open(name).readlines()
	for l in f[:128]:
		l = l.strip().split(" ")
		#print l
		n = float(l[1])
		b = int(l[3][:1])
		if not b:
			n = -n
		print l[0], n

def calc_matches(k, include=[], exclude=[]):

	a = [1] * 128
	for fname, kr in k.items():
		if include:
			if fname not in include:
				continue
		elif fname in exclude:
			continue
		for i in range(128):
			if kr[i] < 0:
				if key[i] == 0:
					a[i] = 0
			if kr[i] > 0:
				if key[i] == 1:
					a[i] = 0
			
	return a

def find_least_bad(k, using):

	res = {}
	for fname in k.keys():
		if fname in using:
			continue
		include = copy(using) + [fname]
		a = calc_matches(k, include=include)
		new_match = reduce(add, a)
		if not res.has_key(new_match):
			res[new_match] = []
		res[new_match].append(fname)
	return res
		
def find_exclude(k, exclude_already, prev_match):

	res = {}
	for fname in k.keys():
		if fname in exclude_already:
			continue
		new_exclude = copy(exclude_already) + [fname]
		a = calc_matches(k, new_exclude)
		new_match = reduce(add, a)
		if new_match > prev_match:
			res[fname] = new_match
	
	return res

def add_up(k, fnames):

	tr = [0.0] * 128
	for fname in fnames:
		tr = map(lambda (x,y): x+y, zip(tr, k[fname]))
	return tr

def key_match_count(a, key):
	return reduce(add, map(lambda (x,y): x and y, zip(a, key)))

if __name__ == '__main__':
	k = {}


	for fname in os.listdir("."):
		if fname[:4] != 'row.':
			continue
		res, key = read_results_file(fname)
		if res is None:
			continue
		k[fname] = res

	tr = add_up(k, k.keys())

	a = calc_matches(k)
	match_len = reduce(add, a)
	print a, 
	print key
	print_match(key, tr)

	options = []
	for f in k.keys():
		options.append([f])

	added_some = 1
	matches = {}

	num_results = 20

	while added_some and num_results > 0:
		num_results -= 1
		added_some = 0

		for i in range(len(options)):
			includes = options[i]

			if not includes:
				continue


			counts = find_least_bad(k, includes)
			match_keys = counts.keys()
			match_keys.sort()
			if not match_keys:
				continue
			match_key = match_keys[-1]

			if match_key < 50:
				options[i] = []
				continue

			added_some = 1
			includes.append(counts[match_key][0])
			a = calc_matches(k, includes)
			kmc = key_match_count(a, key)

			print num_results, match_key, kmc, includes

			if not matches.has_key(kmc):
				matches[kmc] = []
			matches[kmc].append((match_key, kmc, copy(includes)))
		
	mkeys = matches.keys()
	mkeys.sort()
	#mkeys.reverse()
	for mk in mkeys:
		for (match_key, kmc, includes) in matches[mk]:
			tr = add_up(k, includes)
			#a = calc_matches({None: tr})
			#match_len = reduce(add, a)
			print len(includes), match_key, kmc, includes  #, match_len
			print_match(key, tr)
	#print_match(key, kc[16])

